program icz07_Mouse;

uses
  Windows,
  Messages;

const
  ClassName = 'SimpleWinClass';
  AppName   = 'Our First Window';

var
  MouseClick: Boolean = False; // False = no click yet
  hitpoint  : TPoint;

function WndProc(hWnd: HWND; uMsg: UINT; wParam: WPARAM; lParam: LPARAM): LRESULT; stdcall;
var
  dc: HDC;
  ps: TPaintStruct;
begin
  Result := 0;
  case uMsg of
    WM_DESTROY:
      PostQuitMessage(0);
    WM_LBUTTONDOWN:
      begin
        hitpoint.x := LoWord(lParam);
        hitpoint.y := HiWord(lParam);
        MouseClick := True;
        InvalidateRect(hWnd, nil, True);
      end;
    WM_PAINT:
      begin
        dc := BeginPaint(hWnd, ps);
        if MouseClick then
          TextOut(dc, hitpoint.x, hitpoint.y, AppName, lstrlen(AppName));
        EndPaint(hWnd, ps);
      end;
  else
    Result := DefWindowProc(hWnd, uMsg, wParam, lParam);
  end;
end;

var
  wc: TWndClassEx = (
    cbSize       : SizeOf(TWndClassEx);
    style        : CS_HREDRAW or CS_VREDRAW;
    lpfnWndProc  : @WndProc;
    cbClsExtra   : 0;
    cbWndExtra   : 0;
    hbrBackground: COLOR_WINDOW + 1;
    lpszMenuName : nil;
    lpszClassName: ClassName;
    hIconSm      : 0;
  );
  msg: TMsg;
  wnd: HWND;

begin
  wc.hInstance := HInstance;
  wc.hIcon     := LoadIcon(0, IDI_APPLICATION);
  wc.hCursor   := LoadCursor(0, IDC_ARROW);
  RegisterClassEx(wc);
  wnd := CreateWindowEx(0, ClassName, AppName, WS_OVERLAPPEDWINDOW,
    Integer(CW_USEDEFAULT), Integer(CW_USEDEFAULT), Integer(CW_USEDEFAULT),
    Integer(CW_USEDEFAULT), 0, 0, HInstance, nil);
  ShowWindow(wnd, SW_SHOWNORMAL);
  UpdateWindow(wnd);
  while True do
  begin
    if not GetMessage(msg, 0, 0, 0) then
      Break;
    TranslateMessage(msg);
    DispatchMessage(msg);
  end;
  ExitCode := msg.wParam;
end.