program icz08_Menu_02;

{$R 'Resource.res' 'Resource.rc'}

uses
  Windows,
  Messages;

const
  IDM_TEST    = 1;
  IDM_HELLO   = 2;
  IDM_GOODBYE = 3;
  IDM_EXIT    = 4;

const
  ClassName      = 'SimpleWinClass';
  AppName        = 'Our First Window';
  MenuName       = 'FirstMenu';
  Test_string    = 'You selected Test menu item';
  Hello_string   = 'Hello, my friend';
  Goodbye_string = 'See you again, bye';

function WndProc(hWnd: HWND; uMsg: UINT; wParam: WPARAM; lParam: LPARAM): LRESULT; stdcall;
begin
  Result := 0;
  case uMsg of
    WM_DESTROY:
      PostQuitMessage(0);
    WM_COMMAND:
      begin
        case LoWord(wParam) of
          IDM_TEST:
            MessageBox(0, Test_string, AppName, MB_OK);
          IDM_HELLO:
            MessageBox(0, Hello_string, AppName, MB_OK);
          IDM_GOODBYE:
            MessageBox(0, Goodbye_string, AppName, MB_OK);
        else
          DestroyWindow(hWnd);
        end;
      end;
  else
    Result := DefWindowProc(hWnd, uMsg, wParam, lParam);
  end;
end;

var
  wc: TWndClassEx = (
    cbSize       : SizeOf(TWndClassEx);
    style        : CS_HREDRAW or CS_VREDRAW;
    lpfnWndProc  : @WndProc;
    cbClsExtra   : 0;
    cbWndExtra   : 0;
    hbrBackground: COLOR_WINDOW + 1;
    lpszMenuName : nil;
    lpszClassName: ClassName;
    hIconSm      : 0;
  );
  msg  : TMsg;
  wnd  : HWND;
  hMenu: THandle;

begin
  wc.hInstance := HInstance;
  wc.hIcon     := LoadIcon(0, IDI_APPLICATION);
  wc.hCursor   := LoadCursor(0, IDC_ARROW);
  RegisterClassEx(wc);
  hMenu := LoadMenu(HInstance, MenuName);
  wnd := CreateWindowEx(0, ClassName, AppName, WS_OVERLAPPEDWINDOW,
    Integer(CW_USEDEFAULT), Integer(CW_USEDEFAULT), Integer(CW_USEDEFAULT),
    Integer(CW_USEDEFAULT), 0, hMenu, HInstance, nil);
  ShowWindow(wnd, SW_SHOWNORMAL);
  UpdateWindow(wnd);
  while True do
  begin
    if not GetMessage(msg, 0, 0, 0) then
      Break;
    TranslateMessage(msg);
    DispatchMessage(msg);
  end;
  ExitCode := msg.wParam;
end.