program icz11_MoreDialog_01;

{$R 'Resource.res' 'Resource.rc'}

uses
  Windows,
  Messages;

const
  IDM_EXIT   = 1;
  IDM_ABOUT  = 2;
  IDC_EDIT   = 3000;
  IDC_BUTTON = 3001;
  IDC_EXIT   = 3002;

const
  ClassName  = 'SimpleWinClass';
  AppName    = 'Our Main Window';
  MenuName   = 'FirstMenu';
  DlgName    = 'MyDialog';
  TestString = 'Hello, everybody';

var
  hwndDlg: THandle = 0; // Handle to the dialog box

function DlgProc(hWnd: HWND; iMsg: DWORD; wParam: WPARAM; lParam: LPARAM): BOOL; stdcall;
begin
  Result := True;
  case iMsg of
    WM_INITDIALOG:
      SetFocus(GetDlgItem(hWnd, IDC_EDIT));
    WM_CLOSE:
      begin
        EndDialog(hWnd, 0);
        hwndDlg := 0;
      end;
    WM_COMMAND:
      if HiWord(wParam) = BN_CLICKED then
      begin
        case LoWord(wParam) of
          IDC_EXIT:
            SendMessage(hWnd, WM_CLOSE, 0, 0);
          IDC_BUTTON:
            SetDlgItemText(hWnd, IDC_EDIT, TestString);
        end;
      end;
  else
    Result := False;
  end;
end;

function WndProc(hWnd: HWND; uMsg: UINT; wParam: WPARAM; lParam: LPARAM): LRESULT; stdcall;
begin
  Result := 0;
  case uMsg of
    WM_DESTROY:
      PostQuitMessage(0);
    WM_COMMAND:
      if LoWord(wParam) = IDM_ABOUT then
        hwndDlg := CreateDialogParam(HInstance, DlgName, hWnd, @DlgProc, 0)
      else
        DestroyWindow(hWnd);
  else
    Result := DefWindowProc(hWnd, uMsg, wParam, lParam);
  end;
end;

var
  wc: TWndClassEx = (
    cbSize       : SizeOf(TWndClassEx);
    style        : CS_HREDRAW or CS_VREDRAW;
    lpfnWndProc  : @WndProc;
    cbClsExtra   : 0;
    cbWndExtra   : 0;
    hbrBackground: COLOR_WINDOW + 1;
    lpszMenuName : MenuName;
    lpszClassName: ClassName;
    hIconSm      : 0;
  );
  msg: TMsg;
  wnd: HWND;

begin
  wc.hInstance := HInstance;
  wc.hIcon     := LoadIcon(0, IDI_APPLICATION);
  wc.hCursor   := LoadCursor(0, IDC_ARROW);
  RegisterClassEx(wc);
  wnd := CreateWindowEx(WS_EX_CLIENTEDGE, ClassName, AppName,
    WS_OVERLAPPEDWINDOW, Integer(CW_USEDEFAULT), Integer(CW_USEDEFAULT), 300,
    200, 0, 0, HInstance, nil);
  ShowWindow(wnd, SW_SHOWNORMAL);
  UpdateWindow(wnd);
  while True do
  begin
    if not GetMessage(msg, 0, 0, 0) then
      Break;
    if hwndDlg <> 0 then
      if IsDialogMessage(hwndDlg, msg) then
        Continue;
    TranslateMessage(msg);
    DispatchMessage(msg);
  end;
  ExitCode := msg.wParam;
end.