program icz11_MoreDialog_03;

{$R 'Resource.res' 'Resource.rc'}

uses
  Windows,
  Messages,
  CommDlg;

const
  IDM_OPEN = 1;
  IDM_EXIT = 2;

const
  ClassName     = 'SimpleWinClass';
  AppName       = 'Our Main Window';
  MenuName      = 'FirstMenu';
  FilterString  = 'All Files'#0'*.*'#0'Text Files'#0'*.txt'#0#0;
  OurTitle      = '-=Our First Open File Dialog Box=-: Choose the file to open';
  FullPathName  = 'The Full Filename with Path is: ';
  FullName      = 'The Filename is: ';
  ExtensionName = 'The Extension is: ';
  CrLf          = #$0D#$0A;

const
  MAXSIZE    = 260;
  OUTPUTSIZE = 512;

var
  ofn         : TOpenFilename;
  buffer      : array [0..MAXSIZE - 1] of Char;
  OutputString: array [0..OUTPUTSIZE - 1] of Char;

function WndProc(hWnd: HWND; uMsg: UINT; wParam: WPARAM; lParam: LPARAM): LRESULT; stdcall;
begin
  Result := 0;
  case uMsg of
    WM_DESTROY:
      PostQuitMessage(0);
    WM_COMMAND:
      if LoWord(wParam) = IDM_OPEN then
      begin
        ofn.lStructSize := SizeOf(TOpenFilename);
        ofn.hWndOwner   := hWnd;
        ofn.hInstance   := HInstance;
        ofn.lpstrFilter := FilterString;
        ofn.lpstrFile   := buffer;
        ofn.nMaxFile    := MAXSIZE;
        ofn.Flags       := OFN_FILEMUSTEXIST or OFN_PATHMUSTEXIST or
          OFN_LONGNAMES or OFN_EXPLORER or OFN_HIDEREADONLY;
        ofn.lpstrTitle  := OurTitle;
        if GetOpenFileName(ofn) then
        begin
          lstrcpy(OutputString, FullPathName);
          lstrcat(OutputString, ofn.lpstrFile);
          lstrcat(OutputString, CrLf);
          lstrcat(OutputString, FullName);
          lstrcat(OutputString, PChar(@ofn.lpstrFile[ofn.nFileOffset]));
          lstrcat(OutputString, CrLf);
          lstrcat(OutputString, ExtensionName);
          lstrcat(OutputString, PChar(@ofn.lpstrFile[ofn.nFileExtension]));
          MessageBox(hWnd, OutputString, AppName, MB_OK);
          ZeroMemory(@OutputString, OUTPUTSIZE);
        end;
      end else
        DestroyWindow(hWnd);
  else
    Result := DefWindowProc(hWnd, uMsg, wParam, lParam);
  end;
end;

var
  wc: TWndClassEx = (
    cbSize       : SizeOf(TWndClassEx);
    style        : CS_HREDRAW or CS_VREDRAW;
    lpfnWndProc  : @WndProc;
    cbClsExtra   : 0;
    cbWndExtra   : 0;
    hbrBackground: COLOR_WINDOW + 1;
    lpszMenuName : MenuName;
    lpszClassName: ClassName;
    hIconSm      : 0;
  );
  msg: TMsg;
  wnd: HWND;

begin
  wc.hInstance := HInstance;
  wc.hIcon     := LoadIcon(0, IDI_APPLICATION);
  wc.hCursor   := LoadCursor(0, IDC_ARROW);
  RegisterClassEx(wc);
  wnd := CreateWindowEx(WS_EX_CLIENTEDGE, ClassName, AppName,
    WS_OVERLAPPEDWINDOW, Integer(CW_USEDEFAULT), Integer(CW_USEDEFAULT), 300,
    200, 0, 0, HInstance, nil);
  ShowWindow(wnd, SW_SHOWNORMAL);
  UpdateWindow(wnd);
  while True do
  begin
    if not GetMessage(msg, 0, 0, 0) then
      Break;
    TranslateMessage(msg);
    DispatchMessage(msg);
  end;
  ExitCode := msg.wParam;
end.