program icz14_Process;

{$R 'Resource.res' 'Resource.rc'}

uses
  Windows,
  Messages;

const
  IDM_CREATE_PROCESS = 1;
  IDM_TERMINATE      = 2;
  IDM_EXIT           = 3;

const
  ClassName   = 'Win32ASMProcessClass';
  AppName     = 'Win32 ASM Process Example';
  MenuName    = 'FirstMenu';
  programname = 'icz02_MessageBox.exe';

var
  processInfo: TProcessInformation;
  _ExitCode  : DWORD;
  hMenu      : THandle;

function WndProc(hWnd: HWND; uMsg: UINT; wParam: WPARAM; lParam: LPARAM): LRESULT; stdcall;
var
  startInfo: TStartupInfo;
begin
  Result := 0;
  case uMsg of
    WM_DESTROY:
      PostQuitMessage(0);
    WM_INITMENUPOPUP:
      if GetExitCodeProcess(processInfo.hProcess, _ExitCode) then
      begin
        if _ExitCode = STILL_ACTIVE then
        begin
          EnableMenuItem(hMenu, IDM_CREATE_PROCESS, MF_GRAYED);
          EnableMenuItem(hMenu, IDM_TERMINATE, MF_ENABLED);
        end else begin
          EnableMenuItem(hMenu, IDM_CREATE_PROCESS, MF_ENABLED);
          EnableMenuItem(hMenu, IDM_TERMINATE, MF_GRAYED);
        end;
      end else begin
        EnableMenuItem(hMenu, IDM_CREATE_PROCESS, MF_ENABLED);
        EnableMenuItem(hMenu, IDM_TERMINATE, MF_GRAYED);
      end;
    WM_COMMAND:
      if lParam = 0 then
      begin
        case LoWord(wParam) of
          IDM_CREATE_PROCESS:
            begin
              if processInfo.hProcess <> 0 then
              begin
                CloseHandle(processInfo.hProcess);
                processInfo.hProcess := 0;
              end;
              GetStartupInfo(startInfo);
              CreateProcess(programname, nil, nil, nil, False,
                NORMAL_PRIORITY_CLASS, nil, nil, startInfo, processInfo);
              CloseHandle(processInfo.hThread);
            end;
          IDM_TERMINATE:
            begin
              GetExitCodeProcess(processInfo.hProcess, _ExitCode);
              if _ExitCode = STILL_ACTIVE then
                TerminateProcess(processInfo.hProcess, 0);
              CloseHandle(processInfo.hProcess);
              processInfo.hProcess := 0;
            end;
        else
          DestroyWindow(hWnd);
        end;
      end;
  else
    Result := DefWindowProc(hWnd, uMsg, wParam, lParam);
  end;
end;

var
  wc: TWndClassEx = (
    cbSize       : SizeOf(TWndClassEx);
    style        : CS_HREDRAW or CS_VREDRAW;
    lpfnWndProc  : @WndProc;
    cbClsExtra   : 0;
    cbWndExtra   : 0;
    hbrBackground: COLOR_WINDOW + 1;
    lpszMenuName : MenuName;
    lpszClassName: ClassName;
    hIconSm      : 0;
  );
  msg: TMsg;
  wnd: HWND;

begin
  wc.hInstance := HInstance;
  wc.hIcon     := LoadIcon(0, IDI_APPLICATION);
  wc.hCursor   := LoadCursor(0, IDC_ARROW);
  RegisterClassEx(wc);
  wnd := CreateWindowEx(WS_EX_CLIENTEDGE, ClassName, AppName,
    WS_OVERLAPPEDWINDOW, Integer(CW_USEDEFAULT), Integer(CW_USEDEFAULT), 300,
    200, 0, 0, HInstance, nil);
  ShowWindow(wnd, SW_SHOWNORMAL);
  UpdateWindow(wnd);
  hMenu := GetMenu(wnd);
  while True do
  begin
    if not GetMessage(msg, 0, 0, 0) then
      Break;
    TranslateMessage(msg);
    DispatchMessage(msg);
  end;
  ExitCode := msg.wParam;
end.