program icz15_Multithreading;

{$R 'Resource.res' 'Resource.rc'}

uses
  Windows,
  Messages;

const
  IDM_CREATE_THREAD = 1;
  IDM_EXIT          = 2;
  WM_FINISH         = WM_USER + $100;

const
  ClassName = 'Win32ASMThreadClass';
  AppName   = 'Win32 ASM MultiThreading Example';
  MenuName  = 'FirstMenu';

var
  ThreadID: DWORD;
  wnd     : THandle;

function ThreadProc(Param: DWORD): DWORD; stdcall;
var
  Loop: DWORD;
begin
  Result := 0;
  for Loop := 0 to 600000000 do;
  SendMessage(wnd, WM_FINISH, 0, 0);
end;

function WndProc(hWnd: HWND; uMsg: UINT; wParam: WPARAM; lParam: LPARAM): LRESULT; stdcall;
begin
  Result := 0;
  case uMsg of
    WM_DESTROY:
      PostQuitMessage(0);
    WM_COMMAND:
      if lParam = 0 then
      begin
        if LoWord(wParam) = IDM_CREATE_THREAD then
          CloseHandle(CreateThread(nil, 0, @ThreadProc, nil,
            NORMAL_PRIORITY_CLASS, ThreadID))
        else
          DestroyWindow(hWnd);
      end;
    WM_FINISH:
      MessageBox(0, AppName, AppName, MB_OK);
  else
    Result := DefWindowProc(hWnd, uMsg, wParam, lParam);
  end;
end;

var
  wc: TWndClassEx = (
    cbSize       : SizeOf(TWndClassEx);
    style        : CS_HREDRAW or CS_VREDRAW;
    lpfnWndProc  : @WndProc;
    cbClsExtra   : 0;
    cbWndExtra   : 0;
    hbrBackground: COLOR_WINDOW + 1;
    lpszMenuName : MenuName;
    lpszClassName: ClassName;
    hIconSm      : 0;
  );
  msg: TMsg;

begin
  wc.hInstance := HInstance;
  wc.hIcon     := LoadIcon(0, IDI_APPLICATION);
  wc.hCursor   := LoadCursor(0, IDC_ARROW);
  RegisterClassEx(wc);
  wnd := CreateWindowEx(WS_EX_CLIENTEDGE, ClassName, AppName,
    WS_OVERLAPPEDWINDOW, Integer(CW_USEDEFAULT), Integer(CW_USEDEFAULT), 300,
    200, 0, 0, HInstance, nil);
  ShowWindow(wnd, SW_SHOWNORMAL);
  UpdateWindow(wnd);
  while True do
  begin
    if not GetMessage(msg, 0, 0, 0) then
      Break;
    TranslateMessage(msg);
    DispatchMessage(msg);
  end;
  ExitCode := msg.wParam;
end.