program icz16_EventObject;

{$R 'Resource.res' 'Resource.rc'}

uses
  Windows,
  Messages;

const
  IDM_START_THREAD = 1;
  IDM_STOP_THREAD  = 2;
  IDM_EXIT         = 3;
  WM_FINISH        = WM_USER + $100;

const
  ClassName     = 'Win32ASMEventClass';
  AppName       = 'Win32 ASM Event Example';
  MenuName      = 'FirstMenu';
  SuccessString = 'The calculation is completed!';
  StopString    = 'The thread is stopped';

var
  ThreadID   : DWORD;
  hThread    : THandle;
  hEventStart: THandle;
  EventStop  : BOOL = False;

var
  hMenu: THandle;
  wnd  : HWND;

function ThreadProc(Param: DWORD): DWORD; stdcall;
var
  Loop: DWORD;
begin
  while True do
  begin
    WaitForSingleObject(hEventStart, INFINITE);
    for Loop := 0 to 600000000 do
      if EventStop then
      begin
        MessageBox(wnd, StopString, AppName, MB_OK);
        EventStop := False;
      end;
    PostMessage(wnd, WM_FINISH, 0, 0);
    EnableMenuItem(hMenu, IDM_START_THREAD, MF_ENABLED);
    EnableMenuItem(hMenu, IDM_STOP_THREAD, MF_GRAYED);
  end;
end;

function WndProc(hWnd: HWND; uMsg: UINT; wParam: WPARAM; lParam: LPARAM): LRESULT; stdcall;
begin
  Result := 0;
  case uMsg of
    WM_CREATE:
      begin
        hEventStart := CreateEvent(nil, False, False, nil);
        hThread := CreateThread(nil, 0, @ThreadProc, nil, NORMAL_PRIORITY_CLASS,
          ThreadID);
      end;
    WM_DESTROY:
      PostQuitMessage(0);
    WM_COMMAND:
      if lParam = 0 then
      begin
        case LoWord(wParam) of
          IDM_START_THREAD:
            begin
              SetEvent(hEventStart);
              EnableMenuItem(hMenu, IDM_START_THREAD, MF_GRAYED);
              EnableMenuItem(hMenu, IDM_STOP_THREAD, MF_ENABLED);
            end;
          IDM_STOP_THREAD:
            begin
              EventStop := True;
              EnableMenuItem(hMenu, IDM_START_THREAD, MF_ENABLED);
              EnableMenuItem(hMenu, IDM_STOP_THREAD, MF_GRAYED);
            end;
        else
          DestroyWindow(hWnd);
        end;
      end;
    WM_FINISH:
      MessageBox(0, SuccessString, AppName, MB_OK);
  else
    Result := DefWindowProc(hWnd, uMsg, wParam, lParam);
  end;
end;

var
  wc: TWndClassEx = (
    cbSize       : SizeOf(TWndClassEx);
    style        : CS_HREDRAW or CS_VREDRAW;
    lpfnWndProc  : @WndProc;
    cbClsExtra   : 0;
    cbWndExtra   : 0;
    hbrBackground: COLOR_WINDOW + 1;
    lpszMenuName : MenuName;
    lpszClassName: ClassName;
    hIconSm      : 0;
  );
  msg: TMsg;

begin
  wc.hInstance := HInstance;
  wc.hIcon     := LoadIcon(0, IDI_APPLICATION);
  wc.hCursor   := LoadCursor(0, IDC_ARROW);
  RegisterClassEx(wc);
  wnd := CreateWindowEx(WS_EX_CLIENTEDGE, ClassName, AppName,
    WS_OVERLAPPEDWINDOW, Integer(CW_USEDEFAULT), Integer(CW_USEDEFAULT), 300,
    200, 0, 0, HInstance, nil);
  ShowWindow(wnd, SW_SHOWNORMAL);
  UpdateWindow(wnd);
  hMenu := GetMenu(wnd);
  while True do
  begin
    if not GetMessage(msg, 0, 0, 0) then
      Break;
    TranslateMessage(msg);
    DispatchMessage(msg);
  end;
  ExitCode := msg.wParam;
end.