program icz23_TrayIcon;

uses
  Windows,
  Messages,
  ShellAPI;

const
  WM_SHELLNOTIFY = WM_USER + 5;

const
  IDI_TRAY    = 0;
  IDM_RESTORE = 1000;
  IDM_EXIT    = 1010;

const
  ClassName     = 'TrayIconWinClass';
  AppName       = 'TrayIcon Demo';
  RestoreString = '&Restore';
  ExitString    = 'E&xit Program';

var
  note      : TNotifyIconData;
  hPopupMenu: DWORD;

function WndProc(hWnd: HWND; uMsg: UINT; wParam: WPARAM; lParam: LPARAM): LRESULT; stdcall;
var
  pt: TPoint;
begin
  Result := 0;
  case uMsg of
    WM_CREATE:
      begin
        hPopupMenu := CreatePopupMenu;
        AppendMenu(hPopupMenu, MF_STRING, IDM_RESTORE, RestoreString);
        AppendMenu(hPopupMenu, MF_STRING, IDM_EXIT, ExitString);
      end;
    WM_DESTROY:
      begin
        DestroyMenu(hPopupMenu);
        PostQuitMessage(0);
      end;
    WM_SIZE:
      if wParam = SIZE_MINIMIZED then
      begin
        note.cbSize := SizeOf(TNotifyIconData);
        note.Wnd    := hWnd;
        note.uID    := IDI_TRAY;
        note.uFlags := NIF_ICON or NIF_MESSAGE or NIF_TIP;
        note.uCallbackMessage := WM_SHELLNOTIFY;
        note.hIcon  := GetClassLong(hWnd, GCL_HICONSM); // only valid for Win9x
        if note.hIcon = 0 then
          note.hIcon  := GetClassLong(hWnd, GCL_HICON);
        lstrcpy(note.szTip, AppName);
	ShowWindow(hWnd, SW_HIDE);
        Shell_NotifyIcon(NIM_ADD, @note);
      end;
    WM_COMMAND:
      if lParam = 0 then
      begin
        Shell_NotifyIcon(NIM_DELETE, @note);
        if LoWord(wParam) = IDM_RESTORE then
          ShowWindow(hWnd, SW_RESTORE)
        else
          DestroyWindow(hWnd);
      end;
    WM_SHELLNOTIFY:
      if wParam = IDI_TRAY then
      begin
        case lParam of
          WM_RBUTTONDOWN:
            begin
              GetCursorPos(pt);
              SetForegroundWindow(hWnd);
              TrackPopupMenu(hPopupMenu, TPM_RIGHTALIGN or TPM_RIGHTBUTTON,
                pt.x, pt.y, 0, hWnd, nil);
              PostMessage(hWnd, WM_NULL, 0, 0);
            end;
          WM_LBUTTONDBLCLK:
            SendMessage(hWnd, WM_COMMAND, IDM_RESTORE, 0);
        end;
      end;
  else
    Result := DefWindowProc(hWnd, uMsg, wParam, lParam);
  end;
end;

var
  wc: TWndClassEx = (
    cbSize       : SizeOf(TWndClassEx);
    style        : CS_HREDRAW or CS_VREDRAW or CS_DBLCLKS;
    lpfnWndProc  : @WndProc;
    cbClsExtra   : 0;
    cbWndExtra   : 0;
    hbrBackground: COLOR_APPWORKSPACE;
    lpszMenuName : nil;
    lpszClassName: ClassName;
    hIconSm      : 0;
  );
  msg: TMsg;

begin
  wc.hInstance := HInstance;
  wc.hIcon     := LoadIcon(0, IDI_APPLICATION);
  wc.hCursor   := LoadCursor(0, IDC_ARROW);
  RegisterClassEx(wc);
  CreateWindowEx(WS_EX_CLIENTEDGE, ClassName, AppName, WS_OVERLAPPED or
    WS_CAPTION or WS_SYSMENU or WS_MINIMIZEBOX or WS_MAXIMIZEBOX or WS_VISIBLE,
    Integer(CW_USEDEFAULT), Integer(CW_USEDEFAULT), 350, 200, 0, 0, HInstance,
    nil);
  while True do
  begin
    if not GetMessage(msg, 0, 0, 0) then
      Break;
    TranslateMessage(msg);
    DispatchMessage(msg);
  end;
  ExitCode := msg.wParam;
end.