library icz24_MouseHook;

uses
  Windows,
  Messages;

const
  MsgName = 'MouseHookMessage';

var
  hHook       : DWORD;
  WM_MOUSEHOOK: DWORD;

function MouseProc(code: Integer; wparam: WPARAM; lparam: LPARAM): LRESULT stdcall;
begin
  Result := CallNextHookEx(hHook, code, wParam, lParam);
  with PMouseHookStruct(lParam)^ do
    SendMessage(HWND_BROADCAST, WM_MOUSEHOOK, WindowFromPoint(pt), 0);
end;

function InstallHook(hwnd: DWORD): DWORD; stdcall;
begin
  Result := 0;
  hHook := SetWindowsHookEx(WH_MOUSE, MouseProc, HInstance, 0);
  if hHook <> 0 then
    Result := WM_MOUSEHOOK;
end;

procedure UninstallHook; stdcall;
begin
  UnhookWindowsHookEx(hHook);
end;

exports
  InstallHook,
  UninstallHook;

begin
  WM_MOUSEHOOK := RegisterWindowMessage(MsgName);
end.