program icz24_MouseHook;

{$R 'Resource.res' 'Resource.rc'}

uses
  Windows,
  Messages,
  Intrface in 'HookDLL\Intrface.pas';

const
  IDD_MAINDLG   = 101;
  IDC_CLASSNAME = 1000;
  IDC_HANDLE    = 1001;
  IDC_WNDPROC   = 1002;
  IDC_HOOK      = 1004;
  IDC_EXIT      = 1005;

const
  HookText   = '&Hook';
  UnhookText = '&Unhook';
  template   = '%8.8X';

var
  WM_MOUSEHOOK: DWORD = 0;

function DlgFunc(hDlg, uMsg, wParam, lParam: DWORD): BOOL; stdcall;
var
  buffer: array [0..127] of Char;
  buffer1: array [0..127] of Char;
  rect: TRect;
  WndProc: DWORD;
begin
  Result := True;
  case uMsg of
    WM_CLOSE:
      begin
        if WM_MOUSEHOOK <> 0 then
          UninstallHook;
        EndDialog(hDlg, 0);
      end;
    WM_INITDIALOG:
      begin
        GetWindowRect(hDlg, rect);
        SetWindowPos(hDlg, HWND_TOPMOST, rect.left, rect.top, rect.right,
          rect.bottom, SWP_SHOWWINDOW);
      end;
    WM_COMMAND:
      if lParam <> 0 then
      begin
        if HiWord(wParam) = BN_CLICKED then
          if LoWord(wParam) = IDC_EXIT then
            SendMessage(hDlg, WM_CLOSE, 0, 0)
          else
            if WM_MOUSEHOOK = 0 then
            begin
              WM_MOUSEHOOK := InstallHook(hDlg);
              if WM_MOUSEHOOK <> 0 then
                SetDlgItemText(hDlg, IDC_HOOK, UnhookText);
	    end else
            begin
              UninstallHook;
              SetDlgItemText(hDlg, IDC_HOOK, HookText);
              WM_MOUSEHOOK := 0;
              SetDlgItemText(hDlg, IDC_CLASSNAME, nil);
              SetDlgItemText(hDlg, IDC_HANDLE, nil);
              SetDlgItemText(hDlg, IDC_WNDPROC, nil);
            end;
      end;
  else
    Result := False;
    if uMsg = WM_MOUSEHOOK then
      if WM_MOUSEHOOK <> 0 then
      begin
        GetDlgItemText(hDlg, IDC_HANDLE, buffer1, 128);
        wvsprintf(buffer, template, PChar(@wParam));
        if lstrcmpi(buffer, buffer1) <> 0 then
          SetDlgItemText(hDlg, IDC_HANDLE, buffer);
        GetDlgItemText(hDlg, IDC_CLASSNAME, buffer1, 128);
        GetClassName(wParam, buffer, 128);
        if lstrcmpi(buffer, buffer1) <> 0 then
          SetDlgItemText(hDlg, IDC_CLASSNAME, buffer);
        GetDlgItemText(hDlg, IDC_WNDPROC, buffer1, 128);
        WndProc := GetClassLong(wParam, GCL_WNDPROC);
	wvsprintf(buffer, template, PChar(@WndProc));
        if lstrcmpi(buffer, buffer1) <> 0 then
          SetDlgItemText(hDlg, IDC_WNDPROC, buffer);
        Result := True;
      end;
  end;
end;

begin
  DialogBoxParam(HInstance, PChar(IDD_MAINDLG), 0, @DlgFunc, 0);
end.