program icz25_SimpleBitmap;

{$R 'Resource.res' 'Resource.rc'}

uses
  Windows,
  Messages;

const
  IDB_MAIN = 1;

const
  ClassName = 'SimpleWin32ASMBitmapClass';
  AppName   = 'Win32ASM Simple Bitmap Example';

var
  hBitmap: DWORD;

function WndProc(hWnd: HWND; uMsg: UINT; wParam: WPARAM; lParam: LPARAM): LRESULT; stdcall;
var
  ps    : TPaintStruct;
  dc    : HDC;
  hMemDC: HDC;
  rect  : TRect;
begin
  Result := 0;
  case uMsg of
    WM_CREATE:
        hBitmap := LoadBitmap(HInstance, PChar(IDB_MAIN));
    WM_PAINT:
      begin
        dc := BeginPaint(hWnd, ps);
        hMemDC := CreateCompatibleDC(dc);
        SelectObject(hMemDC, hBitmap);
        GetClientRect(hWnd, rect);
        BitBlt(dc, 0, 0, rect.right, rect.bottom, hMemDC, 0, 0, SRCCOPY);
        DeleteDC(hMemDC);
        EndPaint(hWnd, ps);
      end;
    WM_DESTROY:
      begin
        DeleteObject(hBitmap);
        PostQuitMessage(0);
      end;
  else
    Result := DefWindowProc(hWnd, uMsg, wParam, lParam);
  end;
end;

var
  wc: TWndClassEx = (
    cbSize       : SizeOf(TWndClassEx);
    style        : CS_HREDRAW or CS_VREDRAW;
    lpfnWndProc  : @WndProc;
    cbClsExtra   : 0;
    cbWndExtra   : 0;
    hbrBackground: COLOR_WINDOW + 1;
    lpszMenuName : nil;
    lpszClassName: ClassName;
    hIconSm      : 0;
  );
  msg: TMsg;
  wnd: HWND;

begin
  wc.hInstance := HInstance;
  wc.hIcon     := LoadIcon(0, IDI_APPLICATION);
  wc.hCursor   := LoadCursor(0, IDC_ARROW);
  RegisterClassEx(wc);
  wnd := CreateWindowEx(0, ClassName, AppName, WS_OVERLAPPEDWINDOW,
    Integer(CW_USEDEFAULT), Integer(CW_USEDEFAULT), Integer(CW_USEDEFAULT),
    Integer(CW_USEDEFAULT), 0, 0, HInstance, nil);
  ShowWindow(wnd, SW_SHOWNORMAL);
  UpdateWindow(wnd);
  while True do
  begin
    if not GetMessage(msg, 0, 0, 0) then
      Break;
    TranslateMessage(msg);
    DispatchMessage(msg);
  end;
  ExitCode := msg.wParam;
end.