program icz27_TooltipControl;

{$R 'Resource.res' 'Resource.rc'}

uses
  Windows,
  Messages,
  CommCtrl;

const
  IDD_MAINDIALOG = 101;

const
  ToolTipsClassName = 'Tooltips_class32';
  MainDialogText1   = 'This is the upper left area of the dialog';
  MainDialogText2   = 'This is the upper right area of the dialog';
  MainDialogText3   = 'This is the lower left area of the dialog';
  MainDialogText4   = 'This is the lower right area of the dialog';

var
  hwndTool: DWORD;

procedure SetDlgToolArea(hDlg: HWND; lpti: PToolInfo; lpText: PChar; id: DWORD; lprect: PRect); stdcall;
begin
  case id of
    0:
      begin
        lpti^.Rect.Left   := 0;
        lpti^.Rect.Top    := 0;
        lpti^.Rect.Right  := (lprect^.Right - lprect^.Left) div 2;
        lpti^.Rect.Bottom := (lprect^.Bottom - lprect^.Top) div 2;
      end;
    1:
      begin
        lpti^.Rect.Left   := (lprect.Right - lprect.Left) div 2;
	lpti^.Rect.Top    := 0;
        lpti^.Rect.Right  := lprect^.Right - lprect^.Left;
        lpti^.Rect.Bottom := lprect^.Bottom - lprect^.Top;
      end;
    2:
      begin
        lpti^.Rect.Left   := 0;
        lpti^.Rect.Top    := (lprect^.Bottom - lprect^.Top) div 2 + 1;
        lpti^.Rect.Right  := (lprect^.Right - lprect^.Left) div 2;
        lpti^.Rect.Bottom := lprect^.Bottom - lprect^.Top;
      end;
  else
    lpti^.Rect.Left   := (lprect^.Right - lprect^.Left) div 2 + 1;
    lpti^.Rect.Top    := (lprect^.Bottom - lprect^.Top) div 2 + 1;
    lpti^.Rect.Right  := lprect^.Right - lprect^.Left;
    lpti^.Rect.Bottom := lprect^.Bottom - lprect^.Top;
  end;
  lpti.lpszText := lpText;
  SendMessage(hwndTool, TTM_ADDTOOL, 0, Integer(lpti));
end;

function EnumChild(hwndChild: HWND; lParam: LPARAM): BOOL; stdcall;
var
  buffer: array [0..255] of Char;
begin
  Result := True;
  with PToolInfo(lParam)^ do
  begin
    uId := hwndChild;
    uFlags := uFlags or TTF_IDISHWND;
    GetWindowText(hwndChild, buffer, 255);
    lpszText := buffer;
  end;
  SendMessage(hwndTool, TTM_ADDTOOL, 0, lParam);
end;

function DlgProc(hDlg, uMsg, wParam, lParam: DWORD): BOOL; stdcall;
var
  ti  : TToolInfo;
  id  : DWORD;
  rect: TRect;
begin
  Result := True;
  case uMsg of
    WM_INITDIALOG:
      begin
        InitCommonControls;
        hwndTool := CreateWindowEx(0, ToolTipsClassName, nil, TTS_ALWAYSTIP,
          Integer(CW_USEDEFAULT), Integer(CW_USEDEFAULT),
          Integer(CW_USEDEFAULT), Integer(CW_USEDEFAULT), 0, 0, HInstance, nil);
        id := 0;
        ti.cbSize := SizeOf(TToolInfo);
        ti.uFlags := TTF_SUBCLASS;
        ti.hWnd   := hDlg;
        GetWindowRect(hDlg, rect);
        SetDlgToolArea(hDlg, @ti, MainDialogText1, id, @rect);
        Inc(id);
        SetDlgToolArea(hDlg, @ti, MainDialogText2, id, @rect);
        Inc(id);
        SetDlgToolArea(hDlg, @ti, MainDialogText3, id, @rect);
        Inc(id);
        SetDlgToolArea(hDlg, @ti, MainDialogText4, id, @rect);
        EnumChildWindows(hDlg, @EnumChild, Integer(@ti));
      end;
    WM_CLOSE:
      EndDialog(hDlg, 0);
  else
    Result := False;
  end;
end;

begin
  DialogBoxParam(hInstance, PChar(IDD_MAINDIALOG), 0, @DlgProc, 0);
end.