program icz28_Debug01;

uses
  Windows,
  CommDlg;

{$IFNDEF VER130}
// for Delphi 3 and 4
const
  DBG_CONTINUE               = $00010002;
  DBG_EXCEPTION_NOT_HANDLED  = $80010001;
{$ENDIF}

const
  AppName      = 'Win32 Debug Example no.1';
  FilterString = 'Executable Files'#0'*.exe'#0 +
                 'All Files'#0'*.*'#0#0;
  ExitProc     = 'The debuggee exits';
  NewThread    = 'A new thread is created';
  EndThread    = 'A thread is destroyed';
  ProcessInfo  = 'File Handle: $%8.8X'#$0D#$0A +
                 'Process Handle: $%8.8X'#$0D#$0A +
                 'Thread Handle: $%8.8X'#$0D#$0A +
                 'Image Base: $%8.8X'#$0D#$0A +
                 'Start Address: $%8.8X'#0;

var
  ofn      : TOpenFilename;
  buffer   : array [0..511] of Char;
  startinfo: TStartupInfo;
  pi       : TProcessInformation;
  DBEvent  : TDebugEvent;
  InfoParam: array [0..4] of DWORD;

begin
  ofn.lStructSize := SizeOf(TOpenFilename);
  ofn.lpstrFilter := FilterString;
  ofn.lpstrFile   := buffer;
  ofn.nMaxFile    := 512;
  ofn.Flags       := OFN_FILEMUSTEXIST or OFN_PATHMUSTEXIST or OFN_LONGNAMES or
    OFN_EXPLORER or OFN_HIDEREADONLY;
  if GetOpenFileName(ofn) then
  begin
    GetStartupInfo(startinfo);
    if CreateProcess(buffer, nil, nil, nil, False, DEBUG_PROCESS or
      DEBUG_ONLY_THIS_PROCESS, nil, nil, startinfo, pi) then
    begin
      while True do
      begin
	WaitForDebugEvent(DBEvent, INFINITE);
        case DBEvent.dwDebugEventCode of
          EXIT_PROCESS_DEBUG_EVENT:
            begin
              MessageBox(0, ExitProc, AppName, MB_OK or MB_ICONINFORMATION);
              Break;
            end;
          CREATE_PROCESS_DEBUG_EVENT:
            begin
              InfoParam[0] := DBEvent.CreateProcessInfo.hFile;
              InfoParam[1] := DBEvent.CreateProcessInfo.hProcess;
              InfoParam[2] := DBEvent.CreateProcessInfo.hThread;
              InfoParam[3] := DWORD(DBEvent.CreateProcessInfo.lpBaseOfImage);
              InfoParam[4] := DWORD(DBEvent.CreateProcessInfo.lpStartAddress);
              wvsprintf(buffer, ProcessInfo, PChar(@InfoParam));
              MessageBox(0, buffer, AppName, MB_OK or MB_ICONINFORMATION);
            end;
          EXCEPTION_DEBUG_EVENT:
            if DBEvent.Exception.ExceptionRecord.ExceptionCode =
              EXCEPTION_BREAKPOINT then
            begin
              ContinueDebugEvent(DBEvent.dwProcessId, DBEvent.dwThreadId,
                DBG_CONTINUE);
              Continue;
            end;
          CREATE_THREAD_DEBUG_EVENT:
            MessageBox(0, NewThread, AppName, MB_OK or MB_ICONINFORMATION);
          EXIT_THREAD_DEBUG_EVENT:
            MessageBox(0, EndThread, AppName, MB_OK or MB_ICONINFORMATION);
        end;
        ContinueDebugEvent(DBEvent.dwProcessId, DBEvent.dwThreadId,
          DBG_EXCEPTION_NOT_HANDLED);
      end;
      CloseHandle(pi.hThread);
      CloseHandle(pi.hProcess);
    end;
  end;
end.