program icz29_Debug02_01;

uses
  Windows;

{$IFNDEF VER130}
// for Delphi 3 and 4
const
  DBG_CONTINUE               = $00010002;
  DBG_EXCEPTION_NOT_HANDLED  = $80010001;
{$ENDIF}

const
  AppName       = 'Win32 Debug Example no.2';
  ClassName     = 'SimpleWinClass';
  SearchFail    = 'Cannot find the target process';
  TargetPatched = 'Target patched!';

var
  buffer: DWORD = $9090;

var
  DBEvent  : TDebugEvent;
  ProcessId: DWORD;
  context  : TContext;
  Window   : THandle;
  nilDWORD : DWORD absolute 0;

begin
  Window := FindWindow(ClassName, nil);
  if Window <> 0 then
  begin
    GetWindowThreadProcessId(Window, @ProcessId);
    DebugActiveProcess(ProcessId);
    while True do
    begin
      WaitForDebugEvent(DBEvent, INFINITE);
      case DBEvent.dwDebugEventCode of
        EXIT_PROCESS_DEBUG_EVENT:
          Break;
        CREATE_PROCESS_DEBUG_EVENT:
          begin
            context.ContextFlags := CONTEXT_CONTROL;
            GetThreadContext(DBEvent.CreateProcessInfo.hThread, context);
	    WriteProcessMemory(DBEvent.CreateProcessInfo.hProcess,
              Pointer(context.Eip), @buffer, 2, nilDWORD);
            MessageBox(0, TargetPatched, AppName, MB_OK or MB_ICONINFORMATION);
          end;
        EXCEPTION_DEBUG_EVENT:
          if DBEvent.Exception.ExceptionRecord.ExceptionCode =
            EXCEPTION_BREAKPOINT then
          begin
            ContinueDebugEvent(DBEvent.dwProcessId, DBEvent.dwThreadId,
              DBG_CONTINUE);
            Continue;
          end;
      end;
      ContinueDebugEvent(DBEvent.dwProcessId, DBEvent.dwThreadId,
        DBG_EXCEPTION_NOT_HANDLED);
    end;
  end else
    MessageBox(0, SearchFail, AppName, MB_OK or MB_ICONERROR);
end.