program icz30_Debug03;

uses
  Windows,
  CommDlg;

{$IFNDEF VER130}
// for Delphi 3 and 4
const
  DBG_CONTINUE               = $00010002;
  DBG_EXCEPTION_NOT_HANDLED  = $80010001;
{$ENDIF}

const
  AppName      = 'Win32 Debug Example no.4';
  FilterString = 'Executable Files'#0'*.exe'#0 +
                 'All Files'#0'*.*'#0#0;
  ExitProc     = 'The debuggee exits'#$0D#$0A +
                 'Total Instructions executed : %u';

var
  ofn             : TOpenFilename;
  TotalInstruction: DWORD = 0;

var
  buffer   : array [0..511] of Char;
  startinfo: TStartupInfo;
  pi       : TProcessInformation;
  DBEvent  : TDebugEvent;
  context  : TContext;

begin
  ofn.lStructSize := SizeOf(TOpenFilename);
  ofn.lpstrFilter := FilterString;
  ofn.lpstrFile   := buffer;
  ofn.nMaxFile    := 512;
  ofn.Flags       := OFN_FILEMUSTEXIST or OFN_PATHMUSTEXIST or OFN_LONGNAMES or
    OFN_EXPLORER or OFN_HIDEREADONLY;
  if GetOpenFileName(ofn) then
  begin
    GetStartupInfo(startinfo);
    if CreateProcess(buffer, nil, nil, nil, False, DEBUG_PROCESS or
      DEBUG_ONLY_THIS_PROCESS, nil, nil, startinfo, pi) then
    begin
      while True do
      begin
        WaitForDebugEvent(DBEvent, INFINITE);
        case DBEvent.dwDebugEventCode of
          EXIT_PROCESS_DEBUG_EVENT:
            begin
              wvsprintf(buffer, ExitProc, PChar(@TotalInstruction));
              MessageBox(0, buffer, AppName, MB_OK or MB_ICONINFORMATION);
              Break;
            end;
          EXCEPTION_DEBUG_EVENT:
            case DBEvent.Exception.ExceptionRecord.ExceptionCode of
              EXCEPTION_BREAKPOINT:
                begin
                  context.ContextFlags := CONTEXT_CONTROL;
                  GetThreadContext(pi.hThread, context);
                  context.EFlags := context.EFlags or $100;
                  SetThreadContext(pi.hThread, context);
                  ContinueDebugEvent(DBEvent.dwProcessId, DBEvent.dwThreadId,
                    DBG_CONTINUE);
                  Continue;
                end;
              EXCEPTION_SINGLE_STEP:
                begin
                  Inc(TotalInstruction);
                  GetThreadContext(pi.hThread, context);
                  context.EFlags := context.EFlags or $100;
                  SetThreadContext(pi.hThread, context);
                  ContinueDebugEvent(DBEvent.dwProcessId, DBEvent.dwThreadId,
                    DBG_CONTINUE);
                  Continue;
                end;
            end;
        end;
        ContinueDebugEvent(DBEvent.dwProcessId, DBEvent.dwThreadId,
          DBG_EXCEPTION_NOT_HANDLED);
      end;
      CloseHandle(pi.hThread);
      CloseHandle(pi.hProcess);
    end;
  end;
end.