program icz31_ListView;

{$R 'Resource.res' 'Resource.rc'}

uses
  Windows,
  Messages,
  CommCtrl,
  ShellAPI;

const
  IDM_MAINMENU  = 10000;
  IDM_ICON      = LVS_ICON;
  IDM_SMALLICON = LVS_SMALLICON;
  IDM_LIST      = LVS_LIST;
  IDM_REPORT    = LVS_REPORT;

const
  ClassName         = 'ListViewWinClass';
  AppName           = 'Testing a ListView Control';
  ListViewClassName = 'SysListView32';
  Heading1          = 'Filename';
  Heading2          = 'Size';
  FileNamePattern   = '*.*';
  template          = '%u';

var
  FileNameSortOrder: DWORD = 0;
  SizeSortOrder    : DWORD = 0;

var
  hList: THandle;
  hMenu: THandle;

procedure InsertColumn;
var
  lvc: TLVColumn;
begin
  lvc.mask    := LVCF_TEXT or LVCF_WIDTH;
  lvc.pszText := Heading1;
  lvc.cx      := 150;
  SendMessage(hList, LVM_INSERTCOLUMN, 0, Integer(@lvc));
  lvc.mask    := lvc.mask or LVCF_FMT;
  lvc.fmt     := LVCFMT_RIGHT;
  lvc.pszText := Heading2;
  lvc.cx      := 100;
  SendMessage(hList, LVM_INSERTCOLUMN, 1 , Integer(@lvc));
end;

procedure ShowFileInfo(row: Integer; lpFind: PWin32FindData);
var
  lvi   : TLVItem;
  buffer: array [0..19] of Char;
begin
  lvi.mask     := LVIF_TEXT or LVIF_PARAM;
  lvi.iItem    := row;
  lvi.iSubItem := 0;
  lvi.pszText  := lpFInd.cFileName;
  lvi.lParam   := row;
  SendMessage(hList, LVM_INSERTITEM, 0, Integer(@lvi));
  lvi.mask     := LVIF_TEXT;
  Inc(lvi.iSubItem);
  wvsprintf(buffer, template, PChar(@lpFind.nFileSizeLow));
  lvi.pszText  := buffer;
  SendMessage(hList, LVM_SETITEM, 0, Integer(@lvi));
end;

procedure FillFileInfo;
var
  finddata: TWin32FindData;
  FHandle : THandle;
  Loop    : DWORD;
begin
  FHandle := FindFirstFile(FileNamePattern, finddata);
  if FHandle <> INVALID_HANDLE_VALUE then
  begin
    Loop := 0;
    repeat
      if (finddata.dwFileAttributes and FILE_ATTRIBUTE_DIRECTORY = 0) then
      begin
        ShowFileInfo(Loop, @finddata);
        Inc(Loop);
      end;
    until not FindNextFile(FHandle, finddata);
    FindClose(FHandle);
  end;
end;

function String2Dword(Text: PChar): DWORD; stdcall;
var
  Len  : DWORD;
  Loop : DWORD;
  Digit: DWORD;
  Power: DWORD;
begin
  Result := 0;
  Len := lstrlen(Text);
  Loop := 0;
  Power := 1;
  while Loop < Len do
  begin
    Digit := Byte(Text[Len - Loop - 1]) - Byte('0');
    Inc(Result, Digit * Power);
    Power := Power * 10;
    Inc(Loop);
  end;
end;

function CompareFunc(lParam1, lParam2, SortType: LPARAM): Integer; stdcall;
var
  buffer : array [0..255] of Char;
  buffer1: array [0..255] of Char;
  lvi    : TLVItem;
begin
  lvi.mask       := LVIF_TEXT;
  lvi.pszText    := buffer;
  lvi.cchTextMax := 256;
  case SortType of
    1:
      begin
        lvi.iSubItem := 1;
        SendMessage(hList, LVM_GETITEMTEXT, lParam1, Integer(@lvi));
        Result := String2Dword(buffer);
        SendMessage(hList, LVM_GETITEMTEXT, lParam2, Integer(@lvi));
        Result := Result - Integer(String2Dword(buffer));
      end;
    2:
      begin
        lvi.iSubItem := 1;
	SendMessage(hList, LVM_GETITEMTEXT, lParam1, Integer(@lvi));
        Result := String2Dword(buffer);
	SendMessage(hList, LVM_GETITEMTEXT, lParam2, Integer(@lvi));
        Result := Integer(String2Dword(buffer)) - Result;
      end;
    3:
      begin
        lvi.iSubItem := 0;
        SendMessage(hList, LVM_GETITEMTEXT, lParam1, Integer(@lvi));
        lstrcpy(buffer1, buffer);
        SendMessage(hList, LVM_GETITEMTEXT, lParam2, Integer(@lvi));
        Result := lstrcmpi(buffer1, buffer);
      end;
  else
    lvi.iSubItem := 0;
    SendMessage(hList, LVM_GETITEMTEXT, lParam1, Integer(@lvi));
    lstrcpy(buffer1, buffer);
    SendMessage(hList, LVM_GETITEMTEXT, lParam2, Integer(@lvi));
    Result := lstrcmpi(buffer, buffer1);
  end;
end;

procedure UpdatelParam;
var
  lvi : TLVItem;
  Loop: Integer;
begin
  lvi.mask     := LVIF_PARAM;
  lvi.iSubItem := 0;
  lvi.iItem    := 0;
  for Loop := 0 to SendMessage(hList, LVM_GETITEMCOUNT, 0, 0) - 1 do
  begin
    lvi.lParam := lvi.iItem;
    SendMessage(hList, LVM_SETITEM, 0, Integer(@lvi));
    Inc(lvi.iItem);
  end;
end;

procedure ShowCurrentFocus;
var
  lvi   : TLVItem;
  buffer: array [0..255] of Char;
begin
  lvi.iItem      := SendMessage(hList, LVM_GETNEXTITEM, -1 , LVNI_FOCUSED);
  lvi.iSubItem   := 0;
  lvi.mask       := LVIF_TEXT;
  lvi.pszText    := buffer;
  lvi.cchTextMax := 256;
  SendMessage(hList, LVM_GETITEM, 0, Integer(@lvi));
  MessageBox(hList, buffer, AppName, MB_OK);
end;

function WndProc(hWnd: HWND; uMsg: UINT; wParam: WPARAM; lParam: LPARAM): LRESULT; stdcall;
begin
  Result := 0;
  case uMsg of
    WM_CREATE:
      begin
        hList := CreateWindowEx(0, ListViewClassName, nil, LVS_REPORT or
          WS_CHILD or WS_VISIBLE, 0, 0, 0, 0, hWnd, 0, HInstance, nil);
        InsertColumn;
        FillFileInfo;
        SendMessage(hList, LVM_SETTEXTCOLOR, 0, Integer(RGB(255, 255, 255)));
        SendMessage(hList, LVM_SETBKCOLOR, 0, Integer(RGB(0, 0, 0)));
        SendMessage(hList, LVM_SETTEXTBKCOLOR, 0, Integer(RGB(0, 0, 0)));
        hMenu := GetMenu(hWnd);
        CheckMenuRadioItem(hMenu, IDM_ICON, IDM_LIST, IDM_REPORT, MF_CHECKED);
      end;
    WM_COMMAND:
      if lParam = 0 then
      begin
	SetWindowLong(hList, GWL_STYLE, GetWindowLong(hList, GWL_STYLE)
          and not LVS_TYPEMASK or LoWord(wParam));
        CheckMenuRadioItem(hMenu, IDM_ICON, IDM_LIST, LoWord(wParam),
          MF_CHECKED);
      end;
    WM_NOTIFY:
      with PNMHdr(lParam)^ do
        if hwndFrom = hList then
        begin
          case code of
            LVN_COLUMNCLICK:
              with PNMListView(lParam)^ do
                if iSubItem = 1 then
                begin
                  case SizeSortOrder of
                    0, 2:
                      begin
                        SendMessage(hList, LVM_SORTITEMS, 1,
                          Integer(@CompareFunc));
                        UpdatelParam;
                        SizeSortOrder := 1;
                      end;
                  else
                    SendMessage(hList, LVM_SORTITEMS, 2, Integer(@CompareFunc));
                    UpdatelParam;
                    SizeSortOrder := 2;
                  end;
                end else
                begin
                  case FileNameSortOrder of
                    0, 4:
                      begin
                        SendMessage(hList, LVM_SORTITEMS, 3,
                          Integer(@CompareFunc));
                        UpdatelParam;
                        FileNameSortOrder := 3;
                      end;
                  else
                    SendMessage(hList, LVM_SORTITEMS, 4, Integer(@CompareFunc));
                    UpdatelParam;
                    FileNameSortOrder := 4;
                  end;
                end;
            NM_DBLCLK:
              ShowCurrentFocus;
          end;
        end;
    WM_SIZE:
      MoveWindow(hList, 0, 0, LoWord(lParam), HiWord(lParam), True);
    WM_DESTROY:
      PostQuitMessage(0);
  else
    Result := DefWindowProc(hWnd, uMsg, wParam, lParam);
  end;
end;

var
  wc: TWndClassEx = (
    cbSize       : SizeOf(TWndClassEx);
    style        : 0;
    lpfnWndProc  : @WndProc;
    cbClsExtra   : 0;
    cbWndExtra   : 0;
    hbrBackground: COLOR_WINDOW + 1;
    lpszMenuName : PChar(IDM_MAINMENU);
    lpszClassName: ClassName;
    hIconSm      : 0;
  );
  msg: TMsg;
  wnd: HWND;

begin
  InitCommonControls;
  wc.hInstance := HInstance;
  wc.hIcon     := LoadIcon(0, IDI_APPLICATION);
  wc.hCursor   := LoadCursor(0, IDC_ARROW);
  RegisterClassEx(wc);
  wnd := CreateWindowEx(0, ClassName, AppName, WS_OVERLAPPEDWINDOW,
    Integer(CW_USEDEFAULT), Integer(CW_USEDEFAULT), Integer(CW_USEDEFAULT),
    Integer(CW_USEDEFAULT), 0, 0, HInstance, nil);
  ShowWindow(wnd, SW_SHOWNORMAL);
  UpdateWindow(wnd);
  while True do
  begin
    if not GetMessage(msg, 0, 0, 0) then
      Break;
    TranslateMessage(msg);
    DispatchMessage(msg);
  end;
  ExitCode := msg.wParam;
end.
